/*

    File: fnctdsk.h

    Copyright (C) 1998-2002  Christophe GRENIER <grenier@cgsecurity.org>
  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

#define s_head(E) ((E)[1])
#define s_sect(E) (((E)[2]) & 0x3F)
#define s_cyl(E)  (((((E)[2]) & 0xC0)<<2) | ((E)[3]))
#define e_head(E) ((E)[5])
#define e_sect(E) (((E)[6]) & 0x3F)
#define os(E)     ((E)[4])
#define ind_boot(E) ((E)[0])
#define e_cyl(E)  (word)(((((E)[6]) & 0xC0)<<2) | ((E)[7]))

dword C_H_S2LBA(const t_param_disk disk_car,const word, const byte, const byte);
word byte_per_sector(const t_sector);
unsigned int sect_per_cluster(const t_sector);
unsigned int sect_reserv(const t_sector);
unsigned int nbr_fats(const t_sector);
unsigned int nbr_rootdir(const t_sector);
dword nbr_sectB1(const t_sector);
unsigned int media_descr(const t_sector);
word sect_per_FAT(const t_sector);
dword sect_per_FAT32(const t_sector);
word sect_per_track(const t_sector);
word nbr_side(const t_sector);
dword hidden_sect(const t_sector);
dword nbr_sectB2(const t_sector);
dword NT_sect(const t_sector);
byte NT_clustersize(const t_sector);

int bootable(const t_entree E);
dword sect_rel(const t_entree);
dword nbr_sect(const t_entree);
dword get_sect_s(const t_param_disk disk_car,const t_entree);
dword get_sect_e(const t_param_disk disk_car, const t_entree);
void fill_t_diskext(t_diskext, const t_disk, const t_disk,
    const unsigned int,const dword);
int test_over(const t_param_disk disk_car,const t_entree, const t_entree);
dword debut_abs_entree(const t_param_disk disk_car,const t_entree, const t_disk);
dword debut_rel_entree(const t_entree);
dword fin_abs_entree(const t_param_disk disk_car,const t_entree, const t_disk);
dword fin_rel_entree(const t_entree);
dword CHS2LBA(const t_param_disk disk_car,const t_CHS*CHS);
void disk_avant(const t_param_disk disk_car,t_disk);
void disk_apres(const t_param_disk disk_car,t_disk);
void disk_apres_ext(const t_param_disk disk_car,t_diskext);
void inc_CHS(t_CHS *poslimit, t_CHS *pos);
t_disk entree_s2pos(const t_param_disk disk_car,const t_entree, const t_disk, t_disk);
t_disk entree_e2pos(const t_param_disk disk_car,const t_entree, const t_disk, t_disk);
void partition2entree(const t_param_disk disk_car,const dword pos,const t_diskext partition, t_entree *entree);
void build_entree(const t_param_disk disk_car,const t_disk, const t_disk, const t_disk, unsigned char, t_entree*);
int entree2partition(const t_param_disk disk_car, const dword pos, t_diskext partition, const t_entree entree, const unsigned int status,const unsigned int order,const int debug);
const char* errmsg_entree2partition(const unsigned int errcode);
int read_MBR(t_param_disk disk_car,void *buffer);
int write_MBR(t_param_disk disk_car,void *buffer);
int write_clean_table(t_param_disk);
int write_MBR_code(t_param_disk);
int write_MBR_code_aux(unsigned char *buffer);
void dup_t_CHS(t_CHS * CHS_dest, const t_CHS * CHS_source);
void dup_t_param_disk(t_param_disk dest, const t_param_disk src);
int compare_CHS(const t_CHS *CHS1, const t_CHS *CHS2);
int compare2uint(unsigned int a, unsigned int b);
t_list_part element_new(t_diskext part);
t_list_part insert_new_partition(t_list_part list_part, t_diskext part);
t_list_part insert_new_partition_aux(t_list_part list_part, t_list_part new_element);
t_list_part remove_partition(t_list_part list_part, t_list_part element2removed);
t_list_part sort_list_part(t_list_part list_part);
void delete_list_part(t_list_part list_part);
void  partition_reset(t_diskext partition);
t_diskext partition_new(const unsigned int disk);
int compar_diskext(const t_diskext a, const t_diskext b);
unsigned int LBA2sector(const t_param_disk disk_car, const dword sect);
unsigned int LBA2head(const t_param_disk disk_car, const dword sect);
unsigned int LBA2cylinder(const t_param_disk disk_car, const dword sect);
void LBA2CHS(const t_param_disk disk_car,const dword lba, t_CHS*CHS);
int check_list_part(t_list_part list_part);

